﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace kidsvt_lab5_SA
{
    class Device
    {

        // Получить значение на выходе схемы
        static public bool GetDeviceOutput(bool[] inputs, int faultNodeNumber = -1, bool faultType = false)
        {
            bool tmp = false;
            if (faultNodeNumber >= 0 && faultNodeNumber <= 6)
            {
                tmp = inputs[faultNodeNumber];
                inputs[faultNodeNumber] = faultType;
            }

            bool f1 = !(inputs[0] ^ inputs[1]);
            bool f2 = !inputs[2];
            bool f3 = !(inputs[4] & inputs[5]);


            bool f4, f5, f6;

            if (faultNodeNumber == 9) f4 = !(inputs[3] | faultType | inputs[6]);
            else f4 = !(inputs[3] | f3 | inputs[6]);


            if (faultNodeNumber == 8) f5 = faultType | f4;
            else if (faultNodeNumber == 10) f5 = f2 | faultType;
            else f5 = f2 | f4;

            if (faultNodeNumber == 11) f6 = f1 & faultType;
            else if (faultNodeNumber == 7) f6 = faultType & f5;
            else f6 = f1 & f5;

            if (faultNodeNumber == 12)
                f6 = faultType;

            if (faultNodeNumber >= 0 && faultNodeNumber <= 6)   // Возвращаем изменённое значение бита (если меняли)
                inputs[faultNodeNumber] = tmp;

            return f6;
        }
    }
}
