﻿namespace kidsvt_lab7_8
{
    class MemoryCell
    {
        public int Row { get; private set; }
        public int Column { get; private set; }

        public MemoryCell(int row, int column)
        {
            Row = row;
            Column = column;
        }

        

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((MemoryCell) obj);
        }

        protected bool Equals(MemoryCell other)
        {
            return Row == other.Row && Column == other.Column;
        }

        public override int GetHashCode()
        {
            unchecked
            {
                return (Row * 397) ^ Column;
            }
        }
    }
}
