﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.Text;
using System.Windows.Forms;

namespace lab2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            comboBox_faultNumber.DataSource = new[] { "F1", "F2", "F3", "F4", "F5", "F6" };
            comboBox_faultType.DataSource = new[] { "≡1", "≡0" };
        }



        private void button_start_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();

            int faultElement = comboBox_faultNumber.SelectedIndex + 1;
            bool faultType = comboBox_faultType.Text == @"≡1";

            D_Algorithm alg = new D_Algorithm();

            List<Symbol[]> result = alg.FindResultCube(faultElement, faultType);
            foreach (var item in result)
            {
                string set = "";
                for (int i = 0; i < 7; i++)
                {
                    if (item[i] == Symbol.Zero) set += "0 ";
                    else if (item[i] == Symbol.One) set += "1 ";
                    else if (item[i] == Symbol.X) set += "X ";
                }
                string testValue = item[item.Length - 1] == Symbol.D ? "1" : "0";

                listView1.Items.Add(new ListViewItem(new[] {set, testValue} ));
            }

        }



    }
}
